<?php
$opts = getopt('r:t:h:p:P::u:d:');
function usage()
{
    $name = basename($_SERVER['argv'][0]);
    return <<<EOM
    Usage: $name -h host -p port -u user -P [password] [-d database] [-r rows=200] [-t threads=20] [-c iterations=200]

EOM;
}

if (!isset($opts['h'], $opts['p'], $opts['u'], $opts['P'])) {
    die(usage());
}

$opts['r'] = @$opts['r'] ?: 200;
$opts['t'] = @$opts['t'] ?: 10;
$opts['c'] = @$opts['c'] ?: 200;

$opts['d'] = @$opts['d'] ?: 'sample_db';



$c = mysql_connect($opts['h'] . ':' . $opts['p'], $opts['u'], $opts['P']) or die('runner: ' . mysql_error());
mysql_select_db($opts['d'], $c) or die(mysql_error($c));
mysql_query('drop table if exists sample_table', $c) or die(mysql_error($c));
mysql_query('create table sample_table (id int unsigned not null auto_increment primary key) engine=InnoDB') or die(mysql_error($c));

function makeOpts($opts)
{
    $ret = '';
    foreach ($opts as $name => $value) {
        $ret .= ' ' . escapeshellarg('-' . $name) . ($value === false ? '' : (' ' . escapeshellarg($value)));
    }
    return $ret;
}

`rm -Rf *log`;
foreach (range(1, $opts['t']) as $id) {
    $cmd = "php -derror_reporting=-1 -ddisplay_errors=1 thr.php -i $id " . makeOpts($opts);
    shell_exec("$cmd > t$id.log 2>&1 &");
}
sleep(5);
echo `ls -l *log`;
